# $Id: filesview.py,v 1.18 2010/11/22 17:44:57 irees Exp $
from PyQt4 import QtCore, QtGui

import emen2.clients.emdash
import emen2.clients.emdash.models


class FilesView(QtGui.QTreeView):	
	
	signal_dequeue = QtCore.pyqtSignal(unicode, object)
	signal_enqueue = QtCore.pyqtSignal(unicode, object)
	signal_set = QtCore.pyqtSignal(int, unicode, unicode)

	def __init__(self, parent=None):
		super(FilesView, self).__init__(parent=parent)
		self.setItemDelegateForColumn(5, emen2.clients.emdash.models.stardelegate.StarDelegate(parent=self))
		self.setItemDelegateForColumn(6, emen2.clients.emdash.models.progressbardelegate.ProgressBarDelegate(parent=self))

						

	def newfile(self, filename, item):
		"""Watch for new files, scroll to bottom and expand all"""
		self.expandAll()
		sb = self.verticalScrollBar()
		size = sb.maximum()
		sb.setValue(size)



	def mousePressEvent(self, event):
		index = self.indexAt(event.pos())
		
		if index.row() < 0:
			return super(FilesView, self).mousePressEvent(event)	
	
		data = self.model().getmdata(index)
		filename = data.get('_filename')
		recid = data.get('recid')
		headers = self.model().headers
		param = headers[index.column()]		

		if param == "_status":	
			if data.get("recid") != None:
				QtGui.QDesktopServices.openUrl(QtCore.QUrl("%s/record/%s"%(emen2.clients.emdash.config.options.host, data.get("recid"))))

			else:
				editor = emen2.clients.emdash.models.controlmenu.ControlMenu(parent=self, data=data, filename=filename)
				editor.signal_enqueue.connect(self.signal_enqueue)
				editor.popup(self.mapToGlobal(event.pos()))
		
		if data.get('recid') == None:
			param = None
			
		if param == 'tem_magnification_set':
			d, ok = QtGui.QInputDialog.getDouble(self, "Set Magnification", "Magnification (x1000):", data.get('tem_magnification_set', 0), 0, 1000, 2)
			if ok:
				self.signal_set.emit(recid, 'tem_magnification_set', str(d))				

		elif param == 'tem_magnification_set':
			d, ok = QtGui.QInputDialog.getDouble(self, "Set Defocus", "Defocus (underfocus is positive)", data.get('ctf_defocus_set', 0), -100, 100, 2)
			if ok:
				self.signal_set.emit(recid, 'ctf_defocus_set', str(d))					

		elif param == 'tem_magnification_set':
			d, ok = QtGui.QInputDialog.getDouble(self, "Set Dose Rate", "Dose Rate (e/A2/sec)", data.get('tem_dose_rate', 0), 0, 100, 2)
			if ok:
				self.signal_set.emit(recid, 'tem_dose_rate', str(d))					

		elif param == 'tem_magnification_set':
			d, ok = QtGui.QInputDialog.getDouble(self, "Set Exposure Time", "Exposure Time (s)", data.get('time_exposure_tem', 0), 0, 10, 2)
			if ok:
				self.signal_set.emit(recid, 'time_exposure_tem', str(d))					

		elif param == 'assess_image_quality':
			editor = emen2.clients.emdash.models.stardelegate.QualityMenu(parent=self, recid=data.get('recid'), param='assess_image_quality')
			editor.signal_set.connect(self.signal_set)
			editor.popup(self.mapToGlobal(pos))
			

		return super(FilesView, self).mousePressEvent(event)		




__version__ = "$Revision: 1.18 $".split(":")[1][:-1].strip()
