# $Id: proxy.py,v 1.6 2010/12/09 21:59:41 edwlan Exp $

import xmlrpclib

import emen2.clients

# Additional JSON RPC support
try:
	import emen2.clients.emen2proxy
except: raise #pass



##################################
# Main exported DB interface classes
##################################


class DBJSONRPCProxy(object):
	_ctxid = property(lambda s: s.proxy.get_ctxid())
	def __init__(self, host=None, username=None, password=None, ctxid=None):
		self.proxy = emen2.clients.emen2proxy.Emen2Proxy(host)
		if username:
			self.proxy._login(username, password)
		else:
			self.proxy.set_ctxid(ctxid)
		self._host = host

	def __getattr__(self, name):
		return getattr(self.proxy, name)

	def _login(self, username=None, password=None):
		self.proxy._login(username, password)

	def _setContext(self, ctxid):
		self.proxy.set_ctxid(ctxid)

	def _getContext():
		self.proxy.get_ctxid()




class DBXMLRPCProxy(xmlrpclib.ServerProxy):
	"""Provide a more feature-rich DB XMLRPC interface than the bare python xmlrpclib"""

	def __init__(self, host, username=None, password=None, ctxid=None):
		xmlrpclib.ServerProxy.__init__(self, host, allow_none=True)

		self.__username = username
		self.__password = password

		self._ServerProxy__allow_none = True
		self._host = host
		self._handler = self._ServerProxy__handler

		self._setContext(ctxid)


	def __wrap_request(self, method, params):
		try:
			ret = self._ServerProxy__request(method, params)
		except xmlrpclib.Error, err:
			#raise xmlrpclib.Fault(0, "Error: %s"%(err.headers.get('X-Error')))
			raise ValueError, str(err.headers.get('X-Error'))

		except Exception, e:
			raise

		return ret


	def __getattr__(self, name):
		# print "-> ", name
		return xmlrpclib._Method(self.__wrap_request, name)


	def _login(self, username=None, password=None):
		ctxid = self.__wrap_request("login", (username or self.__username, password or self.__password))
		self.__password = None
		return self._setContext(ctxid)


	def _setContext(self, ctxid):
		# ian: todo: make handler a dynamically generated property? maybe not..
		self._ctxid = ctxid
		if self._ctxid != None:
			self._ServerProxy__handler = "%s?ctxid=%s"%(self._handler, self._ctxid)
		return self._ctxid


	def _getContext():
		return self._ctxid


if __name__ == "__main__":
	emen2.clients.opendb()


__version__ = "$Revision: 1.6 $".split(":")[1][:-1].strip()

