# $Id: uploadresource.py,v 1.35 2010/11/21 22:41:45 irees Exp $
import re
import os
import pickle
import traceback
import time
import random
import atexit
import cStringIO
import urllib
import emen2.util.jsonutil

# emen2 imports
import emen2.web.resources.emen2resource
import emen2.util.loganalyzer
import emen2.db.config
g = emen2.db.config.g()

import emen2.web.thumbs



class UploadResource(emen2.web.resources.emen2resource.EMEN2Resource):

	resourcename = 'upload'

	# Look for filename; if PUT, add a reference to the request.content file handle.
	def parse_content(self, request):
		postargs = {}

		if request.getHeader('X-Filename'):
			postargs['filename'] = request.getHeader('X-Filename')

		if request.method == "POST":
			request.content.seek(0)
			content = request.content.read()
			b = re.compile("filename=\"(.+)\"")
			try:
				postargs['filename'] = b.findall(content[:1000])[0]
			except:
				pass

		elif request.method == "PUT":
			postargs['infile'] = request.content

		return postargs


	def _action(self, path=None, postpath=None, args=None, ctxid=None, host=None, method=None, db=None, request=None):

		infile = args.get('infile') or args.get('filedata')
		param = args.get('param', 'file_binary')

		filename = args.get('filename')
		filename = args.get('filename', '').split("/")[-1].split("\\")[-1]
		if not filename:
			raise ValueError, "No filename specified"

		try:
			recid = int(postpath[0])
		except (IndexError, TypeError, ValueError):
			recid = None

		# Is a record included? In JSON format, urlencoded...
		# This will call putrecord and attach the binary to the new record
		# "record" as well as "newrecord" for backwards compat... "newrecord" is semantically better
		newrecord = args.get('newrecord') or args.get('record')
		if newrecord:
			try:
				newrecord = emen2.util.jsonutil.decode(urllib.unquote(newrecord))
			except ValueError, e:
				raise ValueError, "Invalid JSON record: %s"%e


		# First pass, put the binary
		db._starttxn(flags=0)
		with db:
			db._setContext(ctxid, host)
			bdoo = db.putbinary(filename=filename, infile=infile)


		# Second pass, update the record
		db._starttxn(flags=0)
		with db:
			db._setContext(ctxid, host)
			pd = db.getparamdef(param)
			if recid != None:
				newrecord = db.getrecord(recid)
			self.__addbdo(newrecord, pd, bdoo)
			newrecord = db.putrecord(newrecord)
			recid = newrecord.recid
			bdoo = db.putbinary(bdokey=bdoo.get('name'), recid=recid)


		# Create the tiles/previews, in a background process
		try:
			emen2.web.thumbs.run_from_bdo(bdoo)
		except Exception, inst:
			pass

		# Redirect..
		headers = {}
		location = args.get("Location") or args.get("location")
		if location:
			headers['Location'] = location
		headers['X-Resource'] = 'upload'

		# Return the BDO
		return emen2.util.jsonutil.encode(bdoo).encode("utf-8"), headers



	def __addbdo(self, record, pd, bdo):
		if pd.vartype == "binaryimage":
			record[pd.name] = bdo.get('name')
		elif pd.vartype == "binary":
			v = record.get(pd.name, [])
			v.append(bdo.get('name'))
			record[pd.name] = v
		else:
			raise ValueError, "Binaries cannot be stored with this param"




__version__ = "$Revision: 1.35 $".split(":")[1][:-1].strip()
